define("io.ox/office/editframework/app/editcontroller",["io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/baseframework/app/basecontroller","io.ox/office/baseframework/app/extensionregistry","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/view/editdialogs","gettext!io.ox/office/editframework/actions"],function(e,t,n,r,a,o,i,u,c,s){"use strict";var l=e.newRejected,d=t.trimAndCleanString,p=n.globalLogger,f=u.SaveAsType,m=u.GUARD_AVAILABLE,g=u.CONVERTER_AVAILABLE,h=c.SaveAsFileDialog,v=c.SaveAsTemplateDialog,b={query:"",regexp:!1,replace:""};return o.extend({constructor:function(e,t,n,u,c){function y(t,r){var a=n.processUnsavedComment();return a=a.then(function(){switch(t){case f.NATIVE:return new h(n,s(r&&r.encrypted?"Save as (encrypted)":"Save as"),_.noI18n.fix(s("Copy of %1$s",_.noI18n(e.getShortFileName()))));case f.TEMPLATE:return new v(n,s("Save as template (%1$s)",_.noI18n(i.getTemplateExtension(e.getFullFileName()))),e.getShortFileName());case f.PDF:return new h(n,s("Export as PDF"),e.getShortFileName());default:return p.error('EditController.showSaveAsDialog - unknown file type "'+t+'"'),l()}}),a=a.then(function(e){return e.show()}),a=a.then(function(n){var a=_.isString(n.fileName)?d(n.fileName):null;return a?e.saveDocumentAs(n.folderId,a,t,r):(p.error("EditController.showSaveAsDialog - missing file name"),l())})}function E(e,t){_.extend(w,t);var n=u.call(this,e,_.clone(w)),r=_.isString(n)&&n?$.Deferred().reject(n):$.when(n);return r.fail(function(e){p.error("EditController.executeSearch failed",e)}),r}var T=null,w=_.clone(b);o.call(this,e,t,n,c),this.registerUndoManager=function(e){return T!==e&&(this.stopListeningTo(T),T=e,this.updateOnEvent(T),this.update()),this},this.restoreUndoManager=function(){return this.registerUndoManager(t.getUndoManager())},this.registerItems({"app/valid":{parent:"app/imported",enable:function(){return!e.isInternalError()}},"view/toolbars/show":{get:function(){return n.getToolPane().isVisible()},set:function(t){e.setUserSettingsValue("showToolbars",t),n.getToolPane().toggle(t)}},"view/toolbars/tab":{get:function(){return n.getToolBarTabs().getActiveTabId()},set:function(e){n.getToolBarTabs().activateTab(e)},focusTarget:function(e){return"keyboard"===e?n.getToolPane():null}},"view/new/menu":{parent:"app/valid",enable:function(){return r.BROWSER_TAB_SUPPORT}},"view/saveas/menu":{parent:"app/valid",enable:function(){return!e.getLaunchOption("disableSaveAs")}},"view/searchgroup":{parent:"app/valid",get:function(){return n.getSearchGroup().isVisible()},set:function(e){n.getSearchGroup().toggle(e)},focusTarget:function(){return n.getSearchGroup()},shortcut:{keyCode:"F",ctrlOrMeta:!0,value:!0}},"document/ooxml":{enable:function(){return e.isOOXML()}},"document/odf":{enable:function(){return e.isODF()}},"document/acquireedit":{parent:"app/valid",enable:function(){return e.isAcquireEditRightsEnabled()}},"document/acquireeditOrPending":{parent:"app/valid",enable:function(){return e.isAcquireEditRightsEnabledPendingUpdates()},set:function(){e.acquireEditRights()}},"document/ot/enabled":{parent:"app/imported",enable:function(){return e.isOTEnabled()}},"document/reload":{parent:"app/imported",enable:function(){return e.isReloadEnabled()},set:function(){e.reloadDocument()}},"document/editable":{parent:"app/valid",enable:function(){return e.isEditable()}},"document/readonly":{parent:"app/valid",enable:function(){return!e.isEditable()}},"document/fullname":{get:function(){return e.getFullFileName()}},"document/rename":{parent:["document/editable","app/bundled"],enable:function(){return e.isRenameEnabled()},get:function(){return e.getCurrentFileName()},set:function(t){return e.rename(t)},nonblocking:!0},"document/rename/dialog":{parent:"document/rename",set:function(){return n.showRenameDialog()}},"document/undo":{parent:"document/editable",enable:function(){return this.getValue()>0},get:function(){return T.getUndoCount()},set:function(){return T.undo()},shortcut:[{keyCode:"Z",ctrlOrMeta:!0,selector:".app-pane"},{keyCode:"BACKSPACE",alt:!0,selector:".app-pane"}]},"document/redo":{parent:"document/editable",enable:function(){return this.getValue()>0},get:function(){return T.getRedoCount()},set:function(){return T.redo()},shortcut:[{keyCode:"Y",ctrlOrMeta:!0,selector:".app-pane"},{keyCode:"BACKSPACE",shift:!0,alt:!0,selector:".app-pane"}]},"document/saveas/unencrypted":{parent:["app/valid","app/unencrypted"]},"document/saveas/native/dialog":{parent:"document/saveas/unencrypted",set:function(){return y(f.NATIVE)}},"document/saveas/template/dialog":{parent:"document/saveas/unencrypted",set:function(){return y(f.TEMPLATE)}},"document/saveas/encrypted/dialog":{parent:"app/valid",enable:function(){return m&&!e.isExternalStorage()},set:function(){return y(f.NATIVE,{encrypted:!0})}},"document/saveas/pdf/dialog":{parent:"document/saveas/unencrypted",enable:function(){return g},set:function(){return y(f.PDF)}},"document/autosave":{parent:"document/editable",get:function(){return!0},set:function(){n.yell({headline:s("What is AutoSave?"),message:s("In OX Documents all your changes are saved automatically through AutoSave. It is not necessary to save your work manually.")})}},"document/users":{parent:"app/valid",enable:function(){return e.getActiveClients().length>1},get:function(){return n.getCollaboratorMenu().isVisible()},set:function(e){n.getCollaboratorMenu().toggle(e)}},"document/search":{parent:"app/valid"},"document/search/text":{parent:"document/search",get:function(){return w.query},set:function(e,t){if(!t||!t.commitEvent||"custom"!==t.commitEvent.sourceType)return E("search:start",{query:e});w.query=e}},"document/search/regexp":{parent:"document/search",get:function(){return w.regexp},set:function(e){return E("search:start",{regexp:e})}},"document/search/start":{parent:"document/search",set:function(){return E("search:start")}},"document/search/prev":{parent:"document/search",set:function(){return E("search:prev")},shortcut:[{keyCode:"G",ctrlOrMeta:!0,shift:!0},{keyCode:"F3",shift:!0}]},"document/search/next":{parent:"document/search",set:function(){return E("search:next")},shortcut:[{keyCode:"G",ctrlOrMeta:!0},{keyCode:"F3"}]},"document/search/end":{parent:"document/search",set:function(){return E("search:end",{query:"",replace:""})}},"document/search/close":{parent:"document/search",set:function(){return n.getSearchGroup().hide()}},"document/replace":{parent:["document/search","document/editable"]},"document/replace/text":{parent:"document/replace",get:function(){return w.replace},set:function(e){w.replace=e}},"document/replace/next":{parent:"document/replace",set:function(){return E("replace:next")}},"document/replace/all":{parent:"document/replace",set:function(){return E("replace:all")}},"document/new":{parent:"app/valid",set:function(e){r.openEditorChildTab(e,{target_folder_id:a.getStandardDocumentsFolderId(),target_filename:s("unnamed"),new:!0})}},"document/new/encrypted":{parent:"app/valid",enable:function(){return m},set:function(e){return a.authorizeGuardWithTab().then(function(t){r.openEditorChildTab(e,{target_folder_id:a.getStandardDocumentsFolderId(),target_filename:s("unnamed"),crypto_action:"Encrypt",auth_code:t.authCode,new:!0},t.targetTab)})}},"document/new/fromTemplate":{parent:"app/valid",set:function(){r.openPortalChildTab(e.appType)}},"document/open":{parent:"app/valid",enable:function(){return r.BROWSER_TAB_SUPPORT},set:function(){return n.showOpenDocumentDialog()}}}),e.onInit(function(){T=t.getUndoManager(),this.updateOnEvent(T)},this),this.waitForImport(function(){this.updateOnEvent(e,"docs:state:error docs:users docs:editmode")},this),this.registerDestructor(function(){e=c=t=n=null})}})});