define("io.ox/office/presentation/utils/presentationutils",["io.ox/office/tk/utils","io.ox/office/tk/render/rectangle","io.ox/office/drawinglayer/utils/drawingutils","io.ox/office/drawinglayer/view/drawingframe","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom","io.ox/office/textframework/utils/position","gettext!io.ox/office/presentation/main"],function(t,e,i,r,n,o,a,l){"use strict";var p=e.Rectangle,c={};return c.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS=["left","top","width","height","rotation","flipH","flipV"],c.DEFAULT_PLACEHOLDER_TYPE="body",c.TABLE_PLACEHOLDER_TYPE="tbl",c.IMAGE_PLACEHOLDER_TYPE="pic",c.CONTENTBODY="contentbody",c.TITLE_PLACEHOLDER_TYPES={title:1,ctrTitle:1},c.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES={title:1,ctrTitle:1,subTitle:1},c.ODF_MASTER_READONLY_TYPES={title:1,body:1},c.NO_TEXT_PLACEHOLDER_TYPE={media:1,clipArt:1,chart:1,dgm:1,tbl:1,pic:1},c.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY={media:null,clipArt:"image",chart:null,dgm:null,tbl:"table",pic:"image"},c.PLACEHOLDER_TEMPLATE_TEXTS={body:l("Click to add text"),title:l("Click to add title"),ctrTitle:l("Click to add title"),subTitle:l("Click to add subtitle"),media:l("Media clip"),clipArt:l("Online image"),chart:l("Chart"),dgm:l("Smart Art"),tbl:l("Click to add table"),pic:l("Click to add image"),sldNum:l("Slide Number"),ftr:l("Footer"),dt:l("Date")},c.PLACEHOLDER_TEMPLATE_TEXTS_ODF={body:l("Click to add text"),title:l("Click to add title"),ctrTitle:l("Click to add title"),subTitle:l("Click to add text"),media:l("Media clip"),clipArt:l("Online image"),chart:l("Chart"),dgm:l("Smart Art"),tbl:l("Click to add table"),pic:l("Click to add image"),sldNum:l("Slide Number"),ftr:l("Footer"),dt:l("Date")},c.PLACEHOLDER_TEMPLATE_TEXTS_CLICK={pic:l("Click icon to add image"),tbl:l("Click icon to add table"),chart:l("Click icon to add chart"),dgm:l("Click icon to add smart art graphic"),clipArt:l("Click icon to add clip art"),media:l("Click icon to add media")},c.PLACEHOLDER_TEMPLATE_BUTTONS={contentBody:["picture","table"],body:null,title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},c.PLACEHOLDER_TEMPLATE_BUTTONS_ODF={contentBody:["picture","table"],body:["picture","table"],title:null,ctrTitle:null,subTitle:null,media:["media"],clipArt:["clipart"],chart:["chart"],dgm:["smartart"],tbl:["table"],pic:["picture"],sldNum:null,ftr:null,dt:null},c.PLACEHOLDER_DRAWING_NAMES={content:l("Content placeholder"),contentv:l("Vertical content placeholder"),text:l("Text placeholder"),textv:l("Vertical text placeholder"),picture:l("Image placeholder"),table:l("Table placeholder")},c.PLACEHOLDER_TEXT_CONTENT=[l("Edit Master text styles"),l("Second level"),l("Third level"),l("Fourth level"),l("Fifth level")],c.PLACEHOLDER_TITLE_CONTENT=l("Click to edit Master title style"),c.DEFAULT_PLACEHOLDER_INDEX=0,c.isPlaceHolderAttributeSet=function(t){return!(!t||!t.presentation||!t.presentation.phType&&!_.isNumber(t.presentation.phIndex))},c.isTitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&c.TITLE_PLACEHOLDER_TYPES[t.presentation.phType])},c.isTitleOrSubtitlePlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&c.TITLE_OR_SUBTITLE_PLACEHOLDER_TYPES[t.presentation.phType])},c.isBodyPlaceHolderAttributeSet=function(t){return!(!(t&&t.presentation&&_.isNumber(t.presentation.phIndex))||t.presentation.phType!==c.DEFAULT_PLACEHOLDER_TYPE&&t.presentation.phType)},c.isTextBodyPlaceHolderAttributeSet=function(t,e){return!(e||!1||!t||!t.presentation||!_.isNumber(t.presentation.phIndex)||t.presentation.phType!==c.DEFAULT_PLACEHOLDER_TYPE)},c.isContentBodyPlaceHolderAttributeSet=function(t,e){var i=e||!1;return!(!t||!t.presentation||!_.isNumber(t.presentation.phIndex)&&!i||t.presentation.phType&&(!i||t.presentation.phType!==c.DEFAULT_PLACEHOLDER_TYPE))},c.isPlaceHolderWithoutTextAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&c.NO_TEXT_PLACEHOLDER_TYPE[t.presentation.phType])},c.isCustomPromptPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.customPrompt)},c.isODFReadOnlyPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.phType&&c.ODF_MASTER_READONLY_TYPES[t.presentation.phType])},c.isBodyPlaceHolderAttributeSetWithoutIndex=function(t){return!(!t||!t.presentation||_.isNumber(t.presentation.phIndex)||t.presentation.phType!==c.DEFAULT_PLACEHOLDER_TYPE)},c.isUserModifiedPlaceHolderAttributeSet=function(t){return!!(t&&t.presentation&&t.presentation.userTransformed)},c.isPlaceHolderDrawing=function(t){return c.isPlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.getPlaceHolderDrawingType=function(t,e){var i=e||n.getExplicitAttributeSet(t);return i&&i.presentation&&i.presentation.phType?i.presentation.phType:null},c.getPlaceHolderDrawingIndex=function(t,e){var i=e||n.getExplicitAttributeSet(t);return i&&i.presentation&&_.isNumber(i.presentation.phIndex)?i.presentation.phIndex:null},c.isTitlePlaceHolderDrawing=function(t){return c.isTitlePlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.isTitleOrSubtitlePlaceHolderDrawing=function(t){return c.isTitleOrSubtitlePlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.isBodyPlaceHolderDrawing=function(t){return c.isBodyPlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.isTextBodyPlaceHolderDrawing=function(t){return c.isTextBodyPlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.isContentBodyPlaceHolderDrawing=function(t){return c.isContentBodyPlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.isPlaceHolderWithoutTextDrawing=function(t){return c.isPlaceHolderWithoutTextAttributeSet(n.getExplicitAttributeSet(t))},c.isEmptyPlaceHolderDrawing=function(t){var e=n.getExplicitAttributeSet(t),i=!1,r=null;return c.isPlaceHolderWithoutTextAttributeSet(e)?"undefined"!==$(t).attr("data-type")&&(r=c.NO_TEXT_PLACEHOLDER_CONTENT_PROPERTY[e.presentation.phType],e&&r&&e[r]||(i=!0)):c.isPlaceHolderAttributeSet(e)&&(i=o.isEmptyTextframe(t,{ignoreTemplateText:!0})),i},c.isCustomPromptPlaceHolderDrawing=function(t){return c.isCustomPromptPlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.isODFReadOnlyPlaceHolderDrawing=function(t){return c.isODFReadOnlyPlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.isBodyPlaceHolderWithoutIndexDrawing=function(t){return c.isBodyPlaceHolderAttributeSetWithoutIndex(n.getExplicitAttributeSet(t))},c.isUserModifiedPlaceHolderDrawing=function(t){return c.isUserModifiedPlaceHolderAttributeSet(n.getExplicitAttributeSet(t))},c.requiresUserTransformedProperty=function(t){var e=n.getExplicitAttributeSet(t);return c.isPlaceHolderAttributeSet(e)&&!c.isUserModifiedPlaceHolderAttributeSet(e)},c.getDrawingModelDescriptor=function(e,i){var r=n.getExplicitAttributeSet(e),a=t.getBooleanOption(i,"useDefaultValues",!0),l=null;return c.isPlaceHolderAttributeSet(r)&&((l={}).target=o.getTargetContainerId($(e).parent()),l.type=r.presentation.phType,l.index=r.presentation.phIndex,a&&(l.type&&!_.isNumber(l.index)&&(l.index=c.DEFAULT_PLACEHOLDER_INDEX),_.isNumber(l.index)&&!l.type&&(l.type=c.DEFAULT_PLACEHOLDER_TYPE))),l},c.getValidTypeIndexSet=function(e){return e&&e.presentation&&("phType"in e.presentation||"phIndex"in e.presentation)?{type:t.getStringOption(e.presentation,"phType",c.DEFAULT_PLACEHOLDER_TYPE),index:t.getIntegerOption(e.presentation,"phIndex",c.DEFAULT_PLACEHOLDER_INDEX)}:null},c.getPlaceHolderTemplateText=function(t,e){var i=c.getPlaceHolderDrawingType(t),r=e||!1;return!i&&_.isNumber(c.getPlaceHolderDrawingIndex(t))&&(i=c.DEFAULT_PLACEHOLDER_TYPE),i?r?c.PLACEHOLDER_TEMPLATE_TEXTS_ODF[i]:c.PLACEHOLDER_TEMPLATE_TEXTS[i]:null},c.getPlaceHolderTemplateButtonsList=function(t,e){return(e?c.PLACEHOLDER_TEMPLATE_BUTTONS_ODF:c.PLACEHOLDER_TEMPLATE_BUTTONS)[t||"contentBody"]},c.getODFFooterRepresentation=function(t){var e=c.PLACEHOLDER_TEMPLATE_TEXTS_ODF[t];return e?"<"+e+">":""},c.convertAppContentBoxToOperationBox=function(e,i,r){var n=e.getView().getZoomFactor(),o=e.getModel().getSlideById(e.getModel().getActiveSlideId()).offset(),a=e.getView().getContentRootNode(),l=a.offset(),p=a.scrollLeft(),c=a.scrollTop(),d={},u=!!_.isBoolean(r)&&r;return d.left=(i.left-(o.left-l.left)-p)/n,d.top=(i.top-(o.top-l.top)-c)/n,d.width=u?i.width:Math.round(i.width/n),d.height=u?i.height:Math.round(i.height/n),d.left=t.convertLengthToHmm(d.left,"px"),d.top=t.convertLengthToHmm(d.top,"px"),d.width=t.convertLengthToHmm(d.width,"px"),d.height=t.convertLengthToHmm(d.height,"px"),d.left<0&&(d.left=0),d},c.extendPlaceholderProp=function(t,e,i){if(i&&i.attrs&&i.attrs.drawing){var r=n.getExplicitAttributeSet(e);if(c.isPlaceHolderAttributeSet(r)){var o=t.getModel().getDrawingStyles().getElementAttributes(e).drawing;_.each(o,function(t,e){e in i.attrs.drawing||!_.contains(c.PLACEHOLDER_DRAWING_IMPORTANT_ATTRS,e)||e in r.drawing||(i.attrs.drawing[e]=t)})}}},c.checkEventPosition=function(t,e,i,a){var l=!0,p=t.getModel(),d=null,u=null;if(o.isTextSpan(e.target)||o.isParagraphNode(e.target))return l;if(e.target&&$(e.target.parentNode).is(".borders"))return l;if(c.isPlaceHolderDrawing(i))return l;if(r.isGroupDrawingFrame(i))return!l;if(!r.isShapeDrawingFrame(i))return l;var s=r.getCanvasNode(i);if(!s||0===s.length)return l;var g=a||n.getExplicitAttributes(i,"drawing"),T=p.getActiveSlide().offset(),E=0,f=0,h=0,A=0,P=0,L=0,m=g.flipH,x=g.flipV,b=c.normalizeRotationAndGrouping(t,i,e,T),D=b.rect;if(!b.point)return l;h=D.left,A=D.top,P=D.width,L=D.height,E=b.point.left,f=b.point.top,E-=h,f-=A,m&&(E=P-E),x&&(f=L-f),d=Math.max(E-6,0),u=Math.max(f-6,0);var H=s[0].getContext("2d").getImageData(d,u,12,12);return l=!_.every(H.data,function(t){return 0===t})},c.findValidDrawingNodeBehindDrawing=function(t,e,i){for(var n=0,o=!1,a=(r.isGroupedDrawingFrame(i)?r.getGroupNode(i,{farthest:!0,rootNode:t.getModel().getCurrentRootNode()}):i).prevAll(".drawing"),l=a.length,p=null;n<l&&!o;){var d=$(a[n]);n++,(p=c.checkEventPositionInDrawing(t,e.pageX,e.pageY,d))&&(o=!0)}return p},c.checkEventPositionInDrawing=function(e,o,a,l){function d(e,i,r){var n=Math.round(t.convertCssLength(e.css("left"),"px")),o=Math.round(t.convertCssLength(e.css("top"),"px")),a=e.width(),l=e.height(),c=r.flipH,d=r.flipV;return c&&(n=i.width-a-n),d&&(o=i.height-l-o),n+=i.left,o+=i.top,new p(n,o,a,l)}function u(t,n,l){if(r.isTextFrameShapeDrawingFrame(t)&&(L=r.getTextFrameNode(t))){var p=d(L,l,n);i.pointInsideRect({x:h,y:A},p,1)?(m=t,x=!0,b={rect:p,posX:h,posY:A}):L=null}x||c.checkEventPosition(e,{pageX:o,pageY:a,target:null},t,n)&&(m=t,x=!0)}var s=e.getModel().getActiveSlide().offset(),g=n.getExplicitAttributes(l,"drawing"),T=c.normalizeRotationAndGrouping(e,l,{pageX:o,pageY:a},s),E=T.rect,f=T.drawingRect,h=T.point.left,A=T.point.top,P=e.getView().getZoomFactor(),L=null,m=null,x=!1,b=null;return i.pointInsideRect({x:h,y:A},E,6)&&(r.isGroupDrawingFrame(l)?_.each(l.find(".drawing"),function(t){if(!r.isGroupDrawingFrame(t)){t=$(t);var l=c.normalizeRotationAndGrouping(e,t,{pageX:o,pageY:a},s),p=l.rect,d=l.drawingRect;h=l.point.left,A=l.point.top;var g=n.getExplicitAttributes(t,"drawing");i.pointInsideRect({x:h,y:A},p,6)&&u(t,g,d)}}):r.isTableDrawingFrame(l)?function(t){var e=null,r=_.find(t.find("div.cell"),function(t){var r=(t=$(t)).offset(),n=(r.left-s.left)/P,o=(r.top-s.top)/P;return e=new p(n,o,t.width(),t.height()),i.pointInsideRect({x:h,y:A},e,1)});r&&(m=t,L=r,x=!0,b={rect:e,posX:h,posY:A})}(l):u(l,g,f)),x?{drawing:m,textFrameNode:L,info:b}:null},c.normalizeRotationAndGrouping=function(e,o,a,l){function c(i,n){var o=0,a=0,l=r.isGroupedDrawingFrame(i);_.isNumber(n.left)&&_.isNumber(n.top)||(n=e.getModel().getDrawingStyles().getElementAttributes(i).drawing),l?(o=Math.round(t.convertCssLength(i.css("left"),"px")),a=Math.round(t.convertCssLength(i.css("top"),"px"))):(o=t.convertHmmToLength(n.left,"px",1),a=t.convertHmmToLength(n.top,"px",1)),o+=f,a+=h;var c=i.width(),d=i.height();return new p(o,a,c,d)}var d=e.getView().getZoomFactor(),u=r.isGroupedDrawingFrame(o),s=!!a,g=l||{left:0,top:0},T=0,E=0,f=0,h=0,A=0,P=!1,L=n.getExplicitAttributes(o,"drawing"),m=L.rotation,x=o.children(".canvasexpansion").length>0,b=null,D=null;return s&&(_.isNumber(a.pageX)&&_.isNumber(a.pageY)?(T=(a.pageX-g.left)/d,E=(a.pageY-g.top)/d):P=!0),u&&function(e){var o=[];for(o.push(r.getGroupNode(e));r.isGroupedDrawingFrame(_.last(o));)o.push(r.getGroupNode(_.last(o)));o=o.reverse(),_.each(o,function(e){var r=n.getExplicitAttributes(e,"drawing"),o=null;s&&_.isNumber(r.rotation)&&(o=c(e,r),A=i.rotatePointWithAngle(o.centerX(),o.centerY(),T,E,r.rotation),T=A.left,E=A.top),f+=Math.round(t.convertCssLength(e.css("left"),"px")),h+=Math.round(t.convertCssLength(e.css("top"),"px"))})}(o),D=c(o,L),s&&_.isNumber(m)&&0!==m&&(A=i.rotatePointWithAngle(D.centerX(),D.centerY(),T,E,m),T=A.left,E=A.top),x&&function(e,i,r){var n=r.width(),o=r.height(),a=i.flipH,l=i.flipV,p=0,c=0;p=a?-(n-e.width+Math.round(t.convertCssLength(r.css("left"),"px"))):Math.round(t.convertCssLength(r.css("left"),"px")),c=l?-(o-e.height+Math.round(t.convertCssLength(r.css("top"),"px"))):Math.round(t.convertCssLength(r.css("top"),"px")),b=_.copy(e),e.left+=p,e.top+=c,e.width=n,e.height=o}(D,L,r.getCanvasNode(o)),{rect:D,drawingRect:b||D,point:P?null:{left:T,top:E}}},c.getBackgroundTextPosition=function(t,e,i,n){var o=null,l=t.getModel().getCurrentRootNode();if((i=$(i)).parent().is(".emptytextframe"))o=a.getLastTextPositionInTextFrame(l,e);else{var p=i.find("div.p"),c=i.offset();_.each(p,function(e){if(!o){var i=$(e).offset(),r=(i.left-c.left)/t.getView().getZoomFactor(),p=(i.top-c.top)/t.getView().getZoomFactor(),d=n.posX-n.rect.left-r,u=n.posY-n.rect.top-p,s=a.getPositionInsideParagraph(l,e,d,u,100*t.getView().getZoomFactor());s&&s.pos&&(o=s.pos)}})}return o=o||(r.isTableDrawingFrame(e)?a.getLastTextPositionInTableCell(l,i):a.getLastTextPositionInTextFrame(l,e))},c});