define("io.ox/office/spreadsheet/model/formula/funcs/conversionfuncs",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/model/formula/funcs/types"],function(r,t,e,n,o,a,i,s){"use strict";function l(r,t,n,o){if(r.length>n)throw i.ErrorCode.NUM;if(e.isNumber(t)){if(o&&t<r.length||t>n)throw i.ErrorCode.NUM;r.length<t&&(r=(d+r).slice(-t))}return r}function u(r){if(!/^[01]{0,10}$/.test(r))throw i.ErrorCode.NUM;var t=r.length>0?parseInt(r,2):0;return 10===r.length&&/^1/.test(r)?t-1024:t}function f(r){if(!/^[0-7]{0,10}$/.test(r))throw i.ErrorCode.NUM;var t=r.length>0?parseInt(r,8):0;return 10===r.length&&/^[4-7]/.test(r)?t-1073741824:t}function m(r){if(!/^[0-9a-f]{0,10}$/i.test(r))throw i.ErrorCode.NUM;var t=r.length>0?parseInt(r,16):0;return 10===r.length&&/^[89a-f]/i.test(r)?t-1099511627776:t}function h(r,t){if(-r>512||r>511)throw i.ErrorCode.NUM;return r<0&&(r+=1024),l(r.toString(2),t,10,!0)}function c(r,t){if(-r>536870912||r>536870911)throw i.ErrorCode.NUM;return r<0&&(r+=1073741824),l(r.toString(8),t,10,!0)}function v(r,t){if(-r>549755813888||r>549755813887)throw i.ErrorCode.NUM;return r<0&&(r+=1099511627776),l(r.toString(16).toUpperCase(),t,10,!0)}function p(r,t,e){var n=b.getOrConstruct(t,o.ValueMap);n.has(r)&&a.globalLogger.error('duplicate measurement unit "'+t+'" in category "'+r+'"'),n.insert(r,e)}function g(r,t,e,a){n.splitTokens(t).forEach(function(t){if(p(r,t,new M(e)),a&&a.si){var n=Math.pow(10,a.si);o.forEachElement(y,function(o,a){return p(r,a+t,new M(e*Math.pow(n,o)))})}a&&a.bin&&o.forEachElement(C,function(n,o){return p(r,o+t,new M(e*Math.pow(2,n)))})})}function E(r,t,e,o){n.splitTokens(t).forEach(function(t){return p(r,t,new N(e,o))})}function w(){var r=453.59237;g("mass","g",1,{si:1}),g("mass","u",1.660538782e-24,{si:1}),g("mass","lbm",r),g("mass","ozm",r/16),g("mass","grain",r/7e3),g("mass","cwt shweight",100*r),g("mass","ton",2e3*r),g("mass","stone",14*r),g("mass","uk_cwt lcwt hweight",112*r),g("mass","uk_ton LTON brton",2240*r),g("mass","sg",14593.9029372064);var t=9460730472580800,e=.0254,n=.3048,o=.9144,a=1609.344,i=e/6,s=i/12,l=1/39.37*12*3;g("length","m",1,{si:1}),g("length","ang",1e-10,{si:1}),g("length","ly",9460730472580800,{si:1}),g("length","pc parsec",0x6da012f93c9a8c,{si:1}),g("length","in",e),g("length","ft",n),g("length","yd",o),g("length","ell",1.143),g("length","mi",a),g("length","pica",i),g("length","Picapt Pica",s),g("length","Nmi",1852),g("length","survey_mi",1609.3472186944375);var u=Math.pow(e,2);g("area","m2 m^2",1,{si:2}),g("area","ang2 ang^2",1e-20,{si:2}),g("area","ar",100),g("area","Morgen",2500),g("area","ha",1e4),g("area","ly2 ly^2",Math.pow(t,2)),g("area","in2 in^2",u),g("area","ft2 ft^2",Math.pow(n,2)),g("area","yd2 yd^2",Math.pow(o,2)),g("area","mi2 mi^2",Math.pow(a,2)),g("area","Picapt2 Picapt^2 Pica2 Pica^2",Math.pow(s,2)),g("area","Nmi2 Nmi^2",Math.pow(1852,2)),g("area","uk_acre",4840*Math.pow(o,2)),g("area","us_acre",4840*Math.pow(l,2));var f=Math.pow(e,3),m=Math.pow(n,3),h=492892159375e-17,c=.00056826125;g("volume","m3 m^3",1,{si:3}),g("volume","ang3 ang^3",1e-30,{si:3}),g("volume","l L lt",.001,{si:1}),g("volume","ly3 ly^3",Math.pow(t,3)),g("volume","in3 in^3",f),g("volume","ft3 ft^3",m),g("volume","yd3 yd^3",Math.pow(o,3)),g("volume","mi3 mi^3",Math.pow(a,3)),g("volume","Picapt3 Picapt^3 Pica3 Pica^3",Math.pow(s,3)),g("volume","Nmi3 Nmi^3",Math.pow(1852,3)),g("volume","bushel",2150.42*f),g("volume","MTON",40*m),g("volume","GRT regton",100*m),g("volume","tspm",5e-6),g("volume","tsp",h),g("volume","tbs",3*h),g("volume","oz",6*h),g("volume","cup",48*h),g("volume","pt us_pt",96*h),g("volume","qt",192*h),g("volume","gal",768*h),g("volume","barrel",32256*h),g("volume","uk_pt",c),g("volume","uk_qt",2*c),g("volume","uk_gal",8*c);var v=3600;g("time","s sec",1),g("time","mn min",60),g("time","hr",v),g("time","d day",86400),g("time","yr",8766*v),g("speed","m/s m/sec",1,{si:1}),g("speed","m/h m/hr",1/v,{si:1}),g("speed","mph",a/v),g("speed","kn",1852/v),g("speed","admkn",1853.184/v);var p=4.4482216152605;g("force","N",1,{si:1}),g("force","dy dyn",1e-5,{si:1}),g("force","pond",.00980665,{si:1}),g("force","lbf",p);g("pressure","Pa p",1,{si:1}),g("pressure","atm at",101325,{si:1}),g("pressure","mmHg",133.322,{si:1}),g("pressure","Torr",101325/760),g("pressure","psi",p/u);var w=n*p*550;g("power","W w",1,{si:1}),g("power","PS",735.49875),g("power","HP h",w),g("energy","J",1,{si:1}),g("energy","e",1e-7,{si:1}),g("energy","c",4.184,{si:1}),g("energy","cal",4.1868,{si:1}),g("energy","eV ev",1.602176487e-19,{si:1}),g("energy","Wh wh",v,{si:1}),g("energy","HPh hh",w*v),g("energy","flb",n*p),g("energy","BTU btu",1055.05585262),g("magnetism","T",1,{si:1}),g("magnetism","ga",1e-4,{si:1}),g("temperature","K kel",1,{si:1}),E("temperature","C cel",1,273.15),E("temperature","F fah",5/9,459.67),g("temperature","Rank",5/9),E("temperature","Reau",5/4,218.52),g("information","bit",1,{si:1,bin:!0}),g("information","byte",8,{si:1,bin:!0})}Object.defineProperty(t,"__esModule",{value:!0});var d=n.repeatString("0",255),y={Y:24,Z:21,E:18,P:15,T:12,G:9,M:6,k:3,h:2,da:1,e:1,d:-1,c:-2,m:-3,u:-6,n:-9,p:-12,f:-15,a:-18,z:-21,y:-24},C={Yi:80,Zi:70,Ei:60,Pi:50,Ti:40,Gi:30,Mi:20,ki:10},M=function(){function r(r){this.factor=r}return r.prototype.toBase=function(r){return r*this.factor},r.prototype.toUnit=function(r){return r/this.factor},r}(),N=function(){function r(r,t){this.factor=r,this.offset=t}return r.prototype.toBase=function(r){return(r+this.offset)*this.factor},r.prototype.toUnit=function(r){return r/this.factor-this.offset},r}(),O=new s.FunctionSpecBuilder("conversion"),U=new o.ValueMap,b=new o.ValueMap;t.default={ARABIC:O.unary("val:num","val:str",{name:{ooxml:"_xlfn.ARABIC"},resolve:function(r){if((r=r.replace(/^ +| +$/g,"")).length>255)throw i.ErrorCode.VALUE;var t=1;"-"===r[0]&&(t=-1,r=r.substr(1));var e=n.parseRoman(r);return isFinite(e)?t*e:i.ErrorCode.VALUE.throw()}}),BASE:O.ternaryUniOpt1("val:str","val:int",{name:{ooxml:"_xlfn.BASE"},resolve:function(r,t,n){if(r<0||r>9007199254740991)throw i.ErrorCode.NUM;if(t<2||t>36)throw i.ErrorCode.NUM;if(e.isNumber(n)&&(n<0||n>255))throw i.ErrorCode.NUM;return l(r.toString(t).toUpperCase(),n,255)}}),BIN2DEC:O.unary("val:num","val:str",u),BIN2HEX:O.binaryOpt("val:str",["val:str","val:int"],function(r,t){return v(u(r),t)}),BIN2OCT:O.binaryOpt("val:str",["val:str","val:int"],function(r,t){return c(u(r),t)}),COLOR:O.genericFixed("val:num",3,4,{name:{ooxml:null,odf:"ORG.LIBREOFFICE.COLOR"},signature:["val:int","val:int","val:int","val:int"],resolve:function(r,t,e,n){if(n=n||0,r<0||r>255)throw i.ErrorCode.VALUE;if(t<0||t>255)throw i.ErrorCode.VALUE;if(e<0||e>255)throw i.ErrorCode.VALUE;if(n<0||n>255)throw i.ErrorCode.VALUE;return 16777216*n+65536*r+256*t+e}}),CONVERT:O.ternary("val:num",["val:num","val:str","val:str"],function(r,t,e){b.empty()&&w();var n=b.get(t),o=b.get(e);if(!n||!o)throw i.ErrorCode.NA;var a,s;if(n.forEach(function(r,t){if(o.has(t)){if(a)throw i.ErrorCode.NA;a=r,s=o.get(t)}}),!a||!s)throw i.ErrorCode.NA;return s.toUnit(a.toBase(r))}),"CONVERT.ODF":O.ternary("val:num",["val:num","val:str","val:str"],{name:{ooxml:null,odf:"ORG.OPENOFFICE.CONVERT"},hidden:!0}),DEC2BIN:O.binaryUniOpt("val:str","val:int",h),DEC2HEX:O.binaryUniOpt("val:str","val:int",v),DEC2OCT:O.binaryUniOpt("val:str","val:int",c),DECIMAL:O.binary("val:num",["val:str","val:int"],{name:{ooxml:"_xlfn.DECIMAL"},resolve:function(r,t){if(t<2||t>36)throw i.ErrorCode.NUM;if(!U.getOrCreate(t.toString(),function(){var r=t<=10?"0-"+(t-1):"0-9A-"+n.formatAlphabetic(t-10,n.AlphabeticMethod.DIGIT);return new RegExp("^["+r+"]+$","i")}).test(r))throw i.ErrorCode.NUM;var e=parseInt(r,t);return isFinite(e)&&e>=0?e:i.ErrorCode.NUM.throw()}}),HEX2BIN:O.binaryOpt("val:str",["val:str","val:int"],function(r,t){return h(m(r),t)}),HEX2DEC:O.unary("val:num","val:str",m),HEX2OCT:O.binaryOpt("val:str",["val:str","val:int"],function(r,t){return c(m(r),t)}),OCT2BIN:O.binaryOpt("val:str",["val:str","val:int"],function(r,t){return h(f(r),t)}),OCT2DEC:O.unary("val:num","val:str",f),OCT2HEX:O.binaryOpt("val:str",["val:str","val:int"],function(r,t){return v(f(r),t)}),ROMAN:O.binaryUniOpt("val:str","val:int",function(r,t){if((t=t||0)<0||t>=5||r<0||r>3999)throw i.ErrorCode.VALUE;return n.formatRoman(r,t)})}});