define("io.ox/office/spreadsheet/model/formula/funcs/referencefuncs",["require","exports","io.ox/office/tk/types","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/model/formula/utils/types","io.ox/office/spreadsheet/model/formula/utils/dimension","io.ox/office/spreadsheet/model/formula/utils/matrix","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/funcs/types","io.ox/office/spreadsheet/model/formula/tokenarray"],function(e,r,t,o,a,n,s,i,l,u,c,d){"use strict";function f(e,r,t,a){if(r<1||r>=t)throw o.ErrorCode.VALUE;return e.getOperand(r,a?"val:any":"any")}function p(e,r){switch(r.type){case n.ContextType.VAL:var t=r.getRawValue();return function(){return{value:t,offset:0}};case n.ContextType.MAT:var o=r.getMatrix();return function(e){return{value:o.getByIndex(e),offset:e}};case n.ContextType.REF:var a=e.convertToValueRange(r.getRanges()),s=e.getSheetModel(a.sheet1),i=s.cellCollection,l=a.toRange();return function(r,t,o){var a=l.addressAt(r),n=e.getCellValue(s,a);if(null!==n)return{value:n,offset:r};var u=i.findFirstCell(l,{startAddress:a,skipStart:!0,type:"value",covered:!0});if(u){var c=l.indexAt(u);if(c<=o)return{value:e.getCellValue(s,u),offset:c}}var d=i.findFirstCell(l,{startAddress:a,skipStart:!0,type:"value",covered:!0,reverse:!0});if(d){var f=l.indexAt(d);if(t<=f)return{value:e.getCellValue(s,d),offset:f}}}}return n.throwEngineError("createNearestScalarResolver(): unknown operand type")}function v(e,r,t,a,s,i){function l(e){return e||o.ErrorCode.NA.throw()}if((s?a.rows:a.cols)>1)switch(t.type){case n.ContextType.MAT:var u=t.getMatrix(),c=s?u.toRowVector(0):u.toColVector(0);t=e.createOperand(c);break;case n.ContextType.REF:var d=t.getRanges()[0].clone();d.setEnd(d.getStart(!s),!s),t=e.createOperand(d)}if(i===E.EXACT){var f=e.createScalarIterator(t,y),v=e.createScalarMatcher(r);return l(f.find(v))}for(var h,g=p(e,t),C=i===E.LESS?function(t){return e.compareScalars(t,r)<=o.CompareResult.EQUAL}:function(t){return e.compareScalars(t,r)>=o.CompareResult.EQUAL},w=0,A=(s?a.cols:a.rows)-1;w<=A;){var R=g(m((w+A)/2),w,A);if(!R)return l(h);C(R.value)?(h=R,w=R.offset+1):A=R.offset-1}return l(h)}function h(e,r,t,a,s){var i=t?a:s,l=t?s:a;switch(r.type){case n.ContextType.VAL:if(0!==i||0!==l)throw o.ErrorCode.NA;return r.getRawValue();case n.ContextType.MAT:var u=r.getMatrix();if(i>=u.rows()||l>=u.cols())throw o.ErrorCode.NA;return u.values()[i][l];case n.ContextType.REF:var c=r.getRanges()[0],d=e.getSheetModel(c.sheet1),f=c.start.clone();return f[0]+=l,f[1]+=i,e.getCellValue(d,f)}return n.throwEngineError("getScalarAt(): unknown operand type")}function g(e,r,a,n,s,i){var l=a.getDimension({errorCode:o.ErrorCode.VALUE}),u=n?l.rows:l.cols;if(s<1||s>u)throw o.ErrorCode.NA;var c=v(e,r,a,l,n,t.isUndefined(i)||i?E.LESS:E.EXACT);return 1===s?c.value:h(e,a,n,s-1,c.offset)}Object.defineProperty(r,"__esModule",{value:!0});var E,m=Math.floor;!function(e){e.EXACT="exact",e.LESS="less",e.GREATER="greater"}(E||(E={}));var y={emptyParam:!0,emptyCells:!1,acceptErrors:!0},C=new c.FunctionSpecBuilder("reference"),w=C.param("val:int",{mat:"pass"}),A=C.param("ref",{dep:"skip"}),R=C.param("ref:single",{dep:"skip"}),T=C.param("ref:multi",{dep:"skip"}),x=C.param("any",{mat:"pass"}),S=C.param("any",{dep:"skip"}),M=C.param("any",{dep:"skip",mat:"pass"}),O=C.param("any:lazy",{dep:"pass"}),V=C.param("any:lazy",{dep:"pass",mat:"forward"});r.default={ADDRESS:C.genericFixed("val:str",2,5,{signature:["val:int","val:int","val:int","val:bool","val:str"],resolve:function(e,r,s,i,c){var d="";if((s=this.isMissingOrEmptyOperand(2)?1:s)<1||s>4)throw o.ErrorCode.VALUE;i=this.isMissingOrEmptyOperand(3)||i;var f=new l.CellRef(0,0,s%2>0,s<=2),p=new a.Address(0,0);if(i||f.absCol)f.col=r-1;else if(r<0){var v=this.addressFactory.maxCol;f.col=v+r,p[0]=v}else f.col=r,p[0]=0;if(i||f.absRow)f.row=e-1;else if(e<0){var h=this.addressFactory.maxRow;f.row=h+e,p[1]=h}else f.row=e,p[1]=0;this.checkCellRef(f),t.isString(c)&&(c.length>0&&!this.formulaGrammar.isSimpleSheetName(this.docModel,c,{range:!0,external:!0})&&(c=u.encodeComplexSheetName(c)),d=c+"!");var g=i?n.GrammarType.UI_A1:n.GrammarType.UI_RC;return d+this.docModel.getFormulaGrammar(g).formatReference(this.docModel,p,null,null,f,null)}}),AREAS:C.unary("val:num",A,function(e){return e.length}),CHOOSE:C.generic("any",2,{signature:[w,V],resolve:function(e){var r=this,t=this.getOperandCount();if(!n.isValType(this.contextType)&&n.isMatType(this.getOperand(0).type)||n.isMatType(this.contextType)&&!n.isValType(this.getOperand(0).type)){var a=this.getOperands(0).reduce(function(e,r){return s.Dimension.boundary(e,r.getDimension({errorCode:o.ErrorCode.NA}))},null);return this.aggregateMatrix(a,function(){return f(r,r.getOperand(0,"val:int"),t,!0)})}return f(this,e,t)}}),COLUMN:C.unaryOpt("val:num",R,{resolve:function(e){if(e&&n.isMatType(this.contextType)){i.ensureMatrixDim(1,e.cols());var r=e.start[0]+1;return new i.NumberMatrix(1,e.cols(),function(e,t){return r+t})}return(e?this.getMatrixAddress(e):this.getTargetAddress())[0]+1},relColRef:function(e){return 0===e}}),COLUMNS:C.unary("val:num",S,function(e){var r=e.getRawValue();switch(e.type){case n.ContextType.VAL:return o.isErrorCode(r)?r.throw():1;case n.ContextType.MAT:return r.cols();case n.ContextType.REF:return this.convertToRange(r).cols()}return n.throwEngineError("ReferenceFuncs.COLUMNS.resolve(): unknown operand type")}),FORMULATEXT:C.unary("val:str",R,{name:{ooxml:"_xlfn.FORMULATEXT",odf:"FORMULA"},recalc:n.RecalcMode.ALWAYS,resolve:function(e){var r=e.start,t=this.getSheetModel(e.sheet1),a=this.getCellFormula(t,r);if(!a)throw o.ErrorCode.NA;var n="="+a.formula;return a.matrix?"{"+n+"}":n}}),GETPIVOTDATA:C.generic("val:any",2,{hidden:!0,repeatParams:2}),HLOOKUP:C.genericFixed("any",3,4,{signature:["val",x,"val:int","val:bool"],resolve:function(e,r,t,o){return g(this,e,r,!0,t,o)}}),INDEX:C.genericFixed("any",2,4,{recalc:n.RecalcMode.ALWAYS,signature:[S,w,w,w],resolve:function(e,r,a,s){if(t.isNumber(a)||(a=1),t.isNumber(s)||(s=1),r<0||a<0||s<1)throw o.ErrorCode.REF;switch(e.type){case n.ContextType.VAL:if(s>1||r>1||a>1)throw o.ErrorCode.REF;return e;case n.ContextType.MAT:if(s>1)throw o.ErrorCode.REF;var i=e.getRawValue();if(r>i.rows()||a>i.cols())throw o.ErrorCode.REF;return 0===r&&0===a?i:0===r?i.toColVector(a-1):0===a?i.toRowVector(r-1):i.values()[r-1][a-1];case n.ContextType.REF:var l=e.getRawValue()[s-1];if(!l)throw o.ErrorCode.REF;if(!l.singleSheet())throw o.ErrorCode.VALUE;var u=this.getSheetModel(l.sheet1);if(r>l.rows()||a>l.cols())throw o.ErrorCode.REF;return r>0&&(l=l.rowRange(r-1)),a>0&&(l=l.colRange(a-1)),this.isMatrixMode()&&l.single()?this.getCellValue(u,l.start):l}return n.throwEngineError("function INDEX: invalid operand type")}}),INDIRECT:C.binaryOpt("ref",["val:str","val:bool"],{recalc:n.RecalcMode.ALWAYS,resolve:function(e,r){r=this.isMissingOrEmptyOperand(1)||r;var t=this.getRefSheetModel(),a=new d.TokenArray(t,n.FormulaType.LINK),s=r?n.GrammarType.UI_A1:n.GrammarType.UI_RC,i=this.getTargetAddress();a.parseFormula(s,e,i);var l=a.resolveRangeList(i,i,{resolveNames:d.ResolveNamesMode.SIMPLE});return 1===l.length?l.first():o.ErrorCode.REF.throw()}}),LOOKUP:C.ternaryOpt1("any",["val",x,M],{recalc:n.RecalcMode.ALWAYS,resolve:function(e,r,t){n.isValType(r.type)&&o.throwErrorCode(r.getRawValue());var a=r.getDimension({errorCode:o.ErrorCode.VALUE}),s=a.rows<a.cols,i=t&&t.getDimension({errorCode:o.ErrorCode.VALUE});if(i&&i.rows>1&&i.cols>1)throw o.ErrorCode.NA;var l=v(this,e,r,a,s,E.LESS);if(!t||!i){var u=(s?a.rows:a.cols)-1;return 0===u?l.value:h(this,r,s,u,l.offset)}return h(this,t,i.cols>1||1===i.rows&&s,0,l.offset)}}),MATCH:C.ternaryOpt1("val:num",["val",x,"val:num"],function(e,r,a){if(n.isValType(r.type))throw o.throwErrorCode(r.getRawValue()),o.ErrorCode.NA;var s=r.getDimension({errorCode:o.ErrorCode.VALUE});if(s.rows>1&&s.cols>1)throw o.ErrorCode.NA;var i=!t.isNumber(a)||a>0?E.LESS:a<0?E.GREATER:E.EXACT;return v(this,e,r,s,s.cols>1,i).offset+1}),OFFSET:C.genericFixed("ref",3,5,{recalc:n.RecalcMode.ALWAYS,signature:[A,"val:int","val:int","val:int","val:int"],resolve:function(e,r,t,a,n){var s=this.convertToRange(e,{errorCode:o.ErrorCode.VALUE});return s.start[0]+=t,s.start[1]+=r,s.end[0]+=t,s.end[1]+=r,this.isMissingOrEmptyOperand(4)||(s.end[0]=s.start[0]+n-1),this.isMissingOrEmptyOperand(3)||(s.end[1]=s.start[1]+a-1),this.addressFactory.isValidRange(s)?s:o.ErrorCode.REF.throw()}}),ROW:C.unaryOpt("val:num",R,{resolve:function(e){if(e&&n.isMatType(this.contextType)){i.ensureMatrixDim(e.rows(),1);var r=e.start[1]+1;return new i.NumberMatrix(e.rows(),1,function(e){return r+e})}return(e?this.getMatrixAddress(e):this.getTargetAddress())[1]+1},relRowRef:function(e){return 0===e}}),ROWS:C.unary("val:num",S,function(e){var r=e.getRawValue();switch(e.type){case n.ContextType.VAL:return o.isErrorCode(r)?r.throw():1;case n.ContextType.MAT:return r.rows();case n.ContextType.REF:return this.convertToRange(r).rows()}return n.throwEngineError("function ROWS: unknown operand type")}),SHEET:C.unaryOpt("val:num",S,{name:{ooxml:"_xlfn.SHEET"},recalc:n.RecalcMode.ALWAYS,resolve:function(e){if(!e)return this.getRefSheet()+1;var r=e.getRawValue();if(n.isRefType(e.type))return this.convertToRange(r).sheet1+1;if(n.isValType(e.type)){var t=this.docModel.getSheetIndex(this.convertToString(r));return t<0?o.ErrorCode.NA.throw():t+1}throw o.ErrorCode.NA}}),SHEETS:C.unaryOpt("val:num",T,{name:{ooxml:"_xlfn.SHEETS"},recalc:n.RecalcMode.ALWAYS,resolve:function(e){return e?e.sheets():this.docModel.getSheetCount()}}),SWITCH:C.generic("any",3,{name:{ooxml:"_xlfn.SWITCH",odf:null},signature:["val",O,O],resolve:function(e){for(var r=this.getOperandCount(),t=m((r-1)/2),o=0;o<t;o+=1){var a=this.getOperand(2*o+1,"val");if(this.equalScalars(e,a))return this.getOperand(2*o+2)}return this.getOperand(2*t+1)}}),VLOOKUP:C.genericFixed("any",3,4,{signature:["val",x,"val:int","val:bool"],resolve:function(e,r,t,o){return g(this,e,r,!1,t,o)}})}});