define("io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter",["io.ox/office/tk/utils","io.ox/office/tk/object/baseobject","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/presetformattable","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/formulacontext"],function(e,r,t,n,o,a,i,u,l){"use strict";function s(e,r){if(w(r)&&!w(e)&&!R(e))throw new D("expected reference token",S.REFERENCE)}var c=n.ErrorCode,f=n.isErrorCode,p=n.Address,d=n.Range,m=n.Range3DArray,g=a.ContextType,y=a.InternalErrorCode,v=a.isValType,h=a.isMatType,w=a.isRefType,R=a.isAnyType,E=a.isInternalError,T=a.Dimension,k=a.CompareNullMode,x=a.equalScalars,A=a.compareScalars,F=a.scalarToString,b=a.isValidMatrixDim,I=a.Matrix,M=a.throwEngineError,S=a.FormulaErrorCode,D=a.FormulaError,O=a.formulaLogger,N=i.TokenType,C=u.Operand,V=u.OperandResolver,P=l.combineParsedFormats,L=l.FormulaContext,U=r.extend({constructor:function(t,n,a,i,u){function l(e){var r=e.getRange3D(a,i,z,W);return r?new m(r):c.REF}function E(e,r,t){var n=e.resolveNameModel(z);if(!n)return c.NAME;var o=B.getRefAddress(),a={refSheet:z,recalcDirty:q};return t&&(a.matrixRange=d.createFromAddressAndSize(o,t.cols,t.rows)),h(r)&&!t&&(r=g.ANY),n.getTokenArray().interpretFormula(r,p.A1,o,a).value}function k(e){var r=e.getRange3D(i);return r?new m(r):c.REF}function x(e,r){return!r&&e instanceof C?e:B.createOperand(e,r)}function A(e,r,t){var n=e.token,o=null,a=null;switch(O.log("> resolving operand token "+n+" with context type "+r),n.type){case N.LIT:o=(a=n.value)===c.REF?g.REF:g.VAL;break;case N.MAT:a=n.value,o=g.MAT;break;case N.REF:a=l(n),o=g.REF;break;case N.NAME:a=E(n,r,t),o=g.ANY;break;case N.TABLE:a=k(n),o=g.REF;break;default:M('InterpreterInstance.resolveOperandNode(): unknown token type: "'+n.type+'"')}return s(o,r),x(a)}function F(e,r){if("infer"===r){for(var t=j,n=0;t&&n<e.size();n+=1){var a=e.get(n),i=a&&a.format||j;t=P(t,i)}return t}var u=null;switch(r){case"percent":u=o.getPercentId(!0);break;case"currency":u=Y.getCurrencyCode({red:!0});break;case"fraction":u=o.getFractionId(!0);break;case"date":u=o.SYSTEM_DATE_ID;break;case"time":u=o.getTimeId(null,!0);break;case"datetime":u=o.SYSTEM_DATETIME_ID}return null===u?null:Y.getParsedFormat(u)}function S(e,r,t,n,o){return B.checkEvalTime(),x(function(){try{B.setMatrixPosition(n,o);var a=t.map(function(e,t){return e?B.convertOperandToValue(e,r[t].typeSpec):null});return O.logTokens("  resolving with parameters",a),e.resolve.apply(B,a)}catch(e){if(f(e))return e;throw e}}())}function D(e,r,t){if(e.error)throw e.error;var n=e.token;O.log("> processing operator "+n+" with "+e.operands.length+" parameters and context type "+r);var o=e.resource;if(!o)return x(c.NAME);if(s(o.retType,r),!_.isFunction(o.resolve))return O.warn('InterpreterInstance.resolveOperatorNode(): unsupported operator or function "'+n+'"'),x(y.UNSUPPORTED);if(t&&!b(t))return x(y.UNSUPPORTED);var a=new V,i=e.signature;i.forEach(function(n,o){var i=e.operands[o],u=h(r)&&n.preferMat?g.MAT:n.contextType,l=h(u)&&n.forwardDim;a.push(U.bind(null,i,u,l?t:null))});var u=i.map(function(e,r){return"any:lazy"===e.typeSpec?null:a.resolve(r)});if(!t&&v(o.retType)){var l=h(r);if(l||o.allValType){try{u.forEach(function(e,r){if(e&&(l?v(i[r].baseType)&&!v(e.type):h(e.type))){var n=e.getDimension({errorCode:c.VALUE});t=T.boundary(t,n)}})}catch(e){if(f(e))return x(e);throw e}if(t){if(!b(t))return x(y.UNSUPPORTED);r=g.MAT}}}var p=O.takeTime(o.key,function(){try{B.pushOperandResolver(a,r,t);var e=S(o,i,u,0,0),n=o.retType;if(h(n)&&v(e.type)&&(e=x(new I(e.getRawValue()))),R(n)||n===e.type||w(n)&&v(e.type)&&f(e.getRawValue())||v(n)&&h(r)&&h(e.type)||M("InterpreterInstance.resolveOperatorNode(): "+o.key+": operator result type does not match operator return type"),t&&v(e.type)){O.info("  expand scalar result to "+t+" matrix");var l=new I(t.rows,t.cols,function(r,t){if(0===r&&0===t)return e.getRawValue();var n=S(o,i,u,r,t);if(v(n.type))return n.getRawValue();M("InterpreterInstance.resolveOperatorNode(): invalid matrix element type")});e=x(l)}return e}finally{B.popOperandResolver()}}),d=o.format&&!h(r)?F(a,o.format):null;return d?x(p,{format:d}):p}function U(e,r,t){var n=e.operands?D(e,r,t):A(e,r,t);return O.log("< result of "+e+": "+n),n}var Y=t.numberFormatter,j=Y.getStandardFormat(),z=e.getIntegerOption(u,"refSheet",null),W=e.getOption(u,"wrapReferences",!1),q=e.getOption(u,"recalcDirty",!1),B=new L(t,i,u);r.call(this,t),this.getResult=function(e,r){var t=function(){try{return U(n,e,r)}catch(e){if(f(e))return x(e);throw e}}(),o=R(e)?t.type:e,a={value:function(){try{switch(o){case g.VAL:return t.getScalar(null,null);case g.MAT:return t.getMatrix();case g.REF:return t.getRanges();default:M('InterpreterInstance.getResult(): unknown context type: "'+o+'"')}}catch(e){if(f(e))return e;throw e}}()},i=t.format;i&&!i.isStandard()&&(a.format=i);var u=t.url;return null!==u&&(a.url=u),a},this.registerDestructor(function(){t=n=u=Y=B=null})}});return t.extend({constructor:function(r){function n(e,r,t,n){var o=h(e)?new I(n):n;return O.withLogging(function(){O.info("result: type="+r+" code="+t+" value="+F(o))}),{type:r,code:t,value:o}}var o={withCase:"odf"===r.getApp().getFileFormat(),nullMode:k.CONVERT};t.call(this,r),this.equalScalars=function(e,r){return x(e,r,o)},this.compareScalars=function(e,r){return A(e,r,o)},this.createWarnResult=function(e,r){var t=E(r)?r.value:r;return n(e,"warn",r.key,t)},this.createErrorResult=function(e,r){return n(e,"error",r,c.NA)},this.interpretTokens=O.profileMethod("FormulaInterpreter.interpretTokens()",function(t,n,o,a,i){O.log("contextType="+t);var u=new U(r,n,o,a,i);try{var l=h(t)?e.getOption(i,"matrixRange",null):null,s=l?T.createFromRange(l):null,c=u.getResult(t,s);return E(c.value)?this.createWarnResult(t,c.value):(c.type="valid",O.withLogging(function(){O.info("result: type=valid value="+F(c.value)+" format="+c.format+" url="+c.url)}),c)}catch(e){if(f(e))return this.createWarnResult(t,e);if(e instanceof D)return O.warn("  error: "+e.message),this.createErrorResult(t,e.code);throw e}finally{u.destroy()}}),this.registerDestructor(function(){r=null})}})});