define("io.ox/office/spreadsheet/model/formula/parser/rangelistparser",["io.ox/office/tk/utils","io.ox/office/tk/utils/class","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(e,t,r,n,i){"use strict";var s=r.stringifyCol,a=r.stringifyRow,o=n.Range,l=n.RangeArray,g=i.SheetRef,R=i.RefSyntaxType,h=t.extendable(function(e,t){this.docModel=e,this.MAXCOL=e.getMaxCol(),this.MAXROW=e.getMaxRow(),this.grammar=t,this.refGrammar=t.refGrammar,this.addrConfig=this.refGrammar.addrConfig,this.RE=this.refGrammar.RE});h.prototype._initOptions=function(t){this.refSheet=e.getIntegerOption(t,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.extSep=e.getBooleanOption(t,"extSep",!1),this.skipSheets=e.getBooleanOption(t,"skipSheets",!1)},h.prototype._parseSeparator=function(e){var t=this.RE,r=null;return(r=t.RL_SEP_WS.exec(e))?{sep:" ",text:r[0]}:this.extSep&&(r=t.RL_SEP_OTHER.exec(e))?{sep:r[0],text:r[0]}:null},h.prototype.getAddress=function(e,t){return this.addrConfig.getAddress(e,t,this.MAXCOL,this.MAXROW)},h.prototype.getRange=function(e,t,r){var n=this.getAddress(e,t),i="number"==typeof r?this.getAddress(e,r):n;return n&&i?o.createFromAddresses(n,i):null},h.prototype.getColRange=function(e,t,r){var n=this.addrConfig.getCol(e,t,this.MAXCOL),i="number"==typeof r?this.addrConfig.getCol(e,r,this.MAXCOL):n;return n>=0&&i>=0?o.create(n,0,i,this.MAXROW):null},h.prototype.getRowRange=function(e,t,r){var n=this.addrConfig.getRow(e,t,this.MAXROW),i="number"==typeof r?this.addrConfig.getRow(e,r,this.MAXROW):n;return n>=0&&i>=0?o.create(0,n,this.MAXCOL,i):null},h.prototype.createRangeDesc=function(e,t,r){if(!t)return null;if(e){if(e.r1.sheet!==this.refSheet)return null;if(e.r2&&e.r2.sheet!==this.refSheet)return null}return{range:t,text:r}},h.prototype.implParseRange=function(){return e.error("RangeListParserBase.implParseRange(): missing implementation"),null},h.prototype.implFormatRange=function(){return e.error("RangeListParserBase.implFormatRange(): missing implementation"),null},h.prototype.parseRangeList=function(e,t){this._initOptions(t);for(var r="start",n=new l,i=null;"end"!==r;)switch(r){case"start":r="range";break;case"range":var s=this.implParseRange(e);if(!s)return null;n.push(s.range),e=e.substr(s.text.length),r="sep";break;case"sep":if(0===e.length){r="end";break}var a=this._parseSeparator(e);if(!a||null!==i&&i!==a.sep)return null;i=a.sep,e=e.substr(a.text.length),r="range"}return n},h.prototype.formatRangeList=function(t,r){var n=e.getStringOption(r,"sep"," "),i=e.getStringOption(r,"sheetName",null);return l.map(t,function(e){return this.implFormatRange(e,i)},this).join(n)},h.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var u=h.extend(function(e,t){h.call(this,e,t)});u.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0]);if(r=t.RL_COLS_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3,4),r[0]);if(r=t.RL_COL_3D_REF.exec(e))return this.createRangeDesc(null,this.getColRange(r,3),r[0]);if(r=t.RL_ROWS_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3,4),r[0]);if(r=t.RL_ROW_3D_REF.exec(e))return this.createRangeDesc(null,this.getRowRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):(r=t.RL_COLS_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1,2),r[0]):(r=t.RL_COL_REF.exec(e))?this.createRangeDesc(null,this.getColRange(r,1),r[0]):(r=t.RL_ROWS_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1,2),r[0]):(r=t.RL_ROW_REF.exec(e))?this.createRangeDesc(null,this.getRowRange(r,1),r[0]):void 0},u.prototype.implFormatRange=function(e,t){var r=null,n=null;e.single()?r=e.start.toString():this.docModel.isRowRange(e)?(r=a(e.start[1]),n=a(e.end[1])):this.docModel.isColRange(e)?(r=s(e.start[0]),n=s(e.end[0])):(r=e.start.toString(),n=e.end.toString());var i=t?new g(t,!1):null;return this.grammar.formatGenericRange(this.docModel,i,null,r,n)};var c=h.extend(function(e,t){h.call(this,e,t)});c.prototype.implParseRange=function(e){var t=this.RE,r=null;if(this.skipSheets){if(r=t.RL_RANGE_CUBE_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,7),r[0]);if(r=t.RL_RANGE_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3,5),r[0]);if(r=t.RL_CELL_3D_REF.exec(e))return this.createRangeDesc(null,this.getRange(r,3),r[0])}return(r=t.RL_RANGE_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1,3),r[0]):(r=t.RL_CELL_REF.exec(e))?this.createRangeDesc(null,this.getRange(r,1),r[0]):void 0},c.prototype.implFormatRange=function(e,t){var r=e.start.toString(),n=e.single()?null:e.end.toString(),i=t?new g(t,!1):null,s=t&&n?i:null;return this.grammar.formatGenericRange(this.docModel,i,s,r,n)};var f={};return f.create=function(t,r){var n=t.getFormulaGrammar(r);switch(n.REF_SYNTAX){case R.OOX:case R.ODF_UI:return new u(t,n);case R.OF:return new c(t,n)}e.error('RangeListParser.create(): invalid reference syntax: "'+n.REF_SYNTAX+'"')},f});