define("io.ox/office/spreadsheet/model/sheetmodel",["io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/render/rectangle","io.ox/office/editframework/utils/color","io.ox/office/editframework/model/attributedmodel","io.ox/office/editframework/model/viewattributesmixin","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/paneutils","io.ox/office/spreadsheet/utils/sheetselection","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/colrowcollection","io.ox/office/spreadsheet/model/mergecollection","io.ox/office/spreadsheet/model/cellcollection","io.ox/office/spreadsheet/model/hyperlinkcollection","io.ox/office/spreadsheet/model/tablecollection","io.ox/office/spreadsheet/model/validationcollection","io.ox/office/spreadsheet/model/condformatcollection","io.ox/office/spreadsheet/model/drawing/drawingcollection","io.ox/office/spreadsheet/model/drawing/commentcollection","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/tokenarray","io.ox/office/spreadsheet/model/threadedcommentcollection"],function(e,t,i,n,o,r,l,s,a,c,h,u,g,d,f,p,m,C,v,w,S,R,y,b,x){"use strict";function A(e,t){return e&&t?e.boundary(t):e||t||null}var O=t.toEnum,T=i.equalNumberArrays,H=n.arrayForEachReverse,I=n.arrayEvery,P=o.Rectangle,E=c.SheetType,M=c.SplitMode,V=c.Address,z=c.Interval,F=c.Range,B=c.RangeArray,L=c.mergeRanges,k=c.modelLogger,W=u.SheetSelection,N=y.FormulaType,U=b.TokenArray,D=e.TOUCHDEVICE?1.25:1,G={selection:{def:W.createFromAddress(V.A1),validate:function(t){return t instanceof W?t:e.BREAK},equals:function(e,t){return e.equals(t)}},zoom:{def:1,validate:function(t){return _.isNumber(t)?h.getValidZoom(t):e.BREAK}},showGrid:{def:!0,validate:function(e){return!!e}},splitMode:{def:M.SPLIT,validate:function(t){return t||e.BREAK}},splitWidth:{def:0,validate:function(e){return _.isNumber(e)?Math.max(e,0):0}},splitHeight:{def:0,validate:function(e){return _.isNumber(e)?Math.max(e,0):0}},activePane:{def:"bottomRight",validate:/^(top|bottom)(Left|Right)$/},activePaneSide:{def:null,validate:function(e){return/^(left|right|top|bottom)$/.test(e)?e:null}},anchorLeft:{def:0,validate:function(e){return _.isNumber(e)?e:null}},anchorRight:{def:0,validate:function(e){return _.isNumber(e)?e:null}},anchorTop:{def:0,validate:function(e){return _.isNumber(e)?e:null}},anchorBottom:{def:0,validate:function(e){return _.isNumber(e)?e:null}},activeSelection:{def:null,validate:function(e){return e instanceof W?e:null},equals:function(e,t){return!e&&!t||e&&t&&e.equals(t)}},autoFillData:{def:null,validate:function(e){return _.isObject(e)?e:null}}};return l.extend({constructor:k.profileMethod("SheetModel.constructor()",function(t,i,n){function o(e){return B.map(e,function(e){return t.isColRange(e)||t.isRowRange(e)?e:q.mergeCollection.expandRangeToMergedRanges(e)})}function u(e){return q.isCellType()?q.getViewAttribute(e?"splitWidth":"splitHeight"):0}function y(e){var t=u(e);if(0===t)return null;var i=q.getViewAttribute(e?"anchorLeft":"anchorTop"),n=new z(Math.floor(i));if(q.hasFrozenSplit())return n.last=n.first+t-1,n;var o=e?q.colCollection:q.rowCollection,r=o.getScrollAnchorByOffset(o.convertScrollAnchorToHmm(i)+t);return n.last=Math.floor(r),!n.single()&&r%1<.5&&(n.last-=1),!n.single()&&i%1>.5&&(n.first+=1),n}function b(e,t){if(q.hasFrozenSplit()){var i=y(e),n=e?q.colCollection:q.rowCollection;return i?n.getIntervalPosition(i)[t?"size":"sizeHmm"]:0}var o=u(e);return t?q.convertHmmToPixel(o):o}function Z(e,t,i,n){var o=n?"anchorLeft":"anchorTop",r=n?"anchorRight":"anchorBottom",l=n?"splitWidth":"splitHeight";t[i?"some":"someReverse"](function(e){var t=q.hasFrozenSplit()?y(n):null;if(!t)return!0;var s={};if(i){var a=e.size();e.first<t.first?(s[o]=t.first+a,s[r]=t.last+1+a):e.first<=t.last&&(s[l]=t.size()+a,s[r]=t.last+1+a)}else{var c=e.intersect(t);c&&(s[l]=t.size()-c.size(),0===s[l]&&(s[l]=1)),e.first<t.first&&(s[o]=e.first),e.first<=t.last&&(s[r]=e.first,0===s[r]&&(s[r]=1))}if(0===s[l]){var u=q.getViewAttribute("activePane"),g=h.getNextPanePos(u,n?"right":"bottom");u!==g&&(s.activePane=g),y(!n)||(s.splitMode=M.SPLIT)}q.setViewAttributes(s)}),q.trigger(e,t)}var q=this,K=0,j=0;l.call(this,t,n,{trigger:"always",families:"sheet column row"}),s.call(this,G,{changeHandler:function(e){"zoom"in e&&(K=e.zoom,j=K*D)}}),this.postProcessImport=function(){return this.cellCollection.postProcessImport()},this.applyCopySheetOperation=function(e,t){this.setAttributes(t.getExplicitAttributeSet(!0)),this.nameCollection.applyCopySheetOperation(e,t.nameCollection),this.colCollection.applyCopySheetOperation(e,t.colCollection),this.rowCollection.applyCopySheetOperation(e,t.rowCollection),this.mergeCollection.applyCopySheetOperation(e,t.mergeCollection),this.hyperlinkCollection.applyCopySheetOperation(e,t.hyperlinkCollection),this.cellCollection.applyCopySheetOperation(e,t.cellCollection),this.tableCollection.applyCopySheetOperation(e,t.tableCollection),this.validationCollection.applyCopySheetOperation(e,t.validationCollection),this.condFormatCollection.applyCopySheetOperation(e,t.condFormatCollection),this.drawingCollection.applyCopySheetOperation(e,t.drawingCollection),this.commentCollection.applyCopySheetOperation(e,t.commentCollection),this.threadedCommentCollection.applyCopySheetOperation(e,t.threadedCommentCollection),this.setViewAttributes(t.getViewAttributes())},this.getType=function(){return i},this.isSupportedType=function(){return i===E.WORKSHEET||i===E.CHARTSHEET},this.isWorksheet=function(){return i===E.WORKSHEET},this.isChartsheet=function(){return i===E.CHARTSHEET},this.isCellType=function(){return i===E.WORKSHEET||i===E.MACROSHEET},this.getIndex=function(){return t.getSheetIndexOfModel(this)},this.isActive=function(){return this.getIndex()===t.getActiveSheet()},this.getName=function(){return t.getSheetName(this.getIndex())},this.createCellTokenArray=function(){return new U(this,N.CELL)},this.hasUnsavedComment=function(){return this.threadedCommentCollection.hasUnsavedCommentData()},this.discardUnsavedComment=function(){this.threadedCommentCollection.assignUnsavedCommentData(null)},this.convertPixelToHmm=function(t){return e.convertLengthToHmm(t/j,"px")},this.convertHmmToPixel=function(t){return e.convertHmmToLength(t*j,"px",1)},this.getEffectiveZoom=function(){return j},this.getDefaultDigitWidth=function(){return t.getDefaultDigitWidth(j)},this.getTextPadding=function(e){return t.getTextPadding(e,j)},this.getTotalCellPadding=function(e){return t.getTotalCellPadding(e,j)},this.getRowHeight=function(e){return t.getRowHeight(e,j)},this.getSheetRectangle=function(t){var i=e.getBooleanOption(t,"pixel",!1);return new P(0,0,i?this.colCollection.getTotalSize():this.colCollection.getTotalSizeHmm(),i?this.rowCollection.getTotalSize():this.rowCollection.getTotalSizeHmm())},this.getRangeRectangle=function(t,i){var n=e.getBooleanOption(i,"pixel",!1),o=this.colCollection.getIntervalPosition(t.colInterval()),r=this.rowCollection.getIntervalPosition(t.rowInterval());return new P(n?o.offset:o.offsetHmm,n?r.offset:r.offset.Hmm,n?o.size:o.sizeHmm,n?r.size:r.sizeHmm)},this.getCellRectangle=function(t,i){var n=e.getBooleanOption(i,"expandMerged",!1)?this.mergeCollection.getMergedRange(t,"all"):null;if(n)return this.getRangeRectangle(n,i);var o=e.getBooleanOption(i,"pixel",!1),r=this.colCollection.getEntry(t[0]),l=this.rowCollection.getEntry(t[1]);return new P(o?r.offset:r.offsetHmm,o?l.offset:l.offsetHmm,o?r.size:r.sizeHmm,o?l.size:l.sizeHmm)},this.getAnchorRectangle=function(e){return this.getCellRectangle(e,{pixel:!0,expandMerged:!0})},this.getRangeFromRectangle=function(e,t){var i=this.colCollection.getEntryByOffset(e.left,t),n=this.rowCollection.getEntryByOffset(e.top,t),o=this.colCollection.getEntryByOffset(e.right()-1,t),r=this.rowCollection.getEntryByOffset(e.bottom()-1,t);return F.create(i.index,n.index,o.index,r.index)},this.getUsedRange=function(){var e=this.cellCollection.getUsedRange();return e=A(e,this.mergeCollection.getUsedRange())},this.isSingleCellInRange=function(e){return e.single()||!!this.mergeCollection.getBoundingMergedRange(e)},this.getContentRangeForCell=function(e){return this.isSingleCellInRange(e)?this.cellCollection.findContentRange(e):e},this.areRangesHidden=function(e){return I(e,function(e){return this.colCollection.isIntervalHidden(e.colInterval())&&this.rowCollection.isIntervalHidden(e.rowInterval())},this)},this.getVisibleRanges=function(e){return B.map(e,function(e){var t=this.colCollection.getVisibleIntervals(e.colInterval()),i=this.rowCollection.getVisibleIntervals(e.rowInterval());return B.createFromIntervals(t,i)},this)},this.getVisibleCell=function(e,t){var i=this.colCollection.getVisibleEntry(e[0],t),n=this.rowCollection.getVisibleEntry(e[1],t);return i&&n?new V(i.index,n.index):null},this.shrinkRangeToVisible=function(e,t){var i="rows"!==t?this.colCollection.shrinkIntervalToVisible(e.colInterval()):e.colInterval(),n=i?"columns"!==t?this.rowCollection.shrinkIntervalToVisible(e.rowInterval()):e.rowInterval():null;return n?F.createFromIntervals(i,n):null},this.expandRangeToHidden=function(e){var t=this.colCollection.expandIntervalToHidden(e.colInterval()),i=this.rowCollection.expandIntervalToHidden(e.rowInterval());return F.createFromIntervals(t,i)},this.mergeAndShrinkRanges=function(e){return e=B.map(e,this.expandRangeToHidden,this).merge(),B.map(e,this.shrinkRangeToVisible,this)},this.hasColSplit=function(){return u(!0)>0},this.hasRowSplit=function(){return u(!1)>0},this.hasSplit=function(){return this.hasColSplit()||this.hasRowSplit()},this.getSplitMode=function(){return this.hasSplit()?this.getViewAttribute("splitMode"):null},this.hasDynamicSplit=function(){var e=this.getSplitMode();return e===M.SPLIT||e===M.FROZEN_SPLIT},this.hasFrozenSplit=function(){var e=this.getSplitMode();return e===M.FROZEN||e===M.FROZEN_SPLIT},this.getSplitWidthHmm=function(){return b(!0,!1)},this.getSplitHeightHmm=function(){return b(!1,!1)},this.getSplitWidth=function(){return b(!0,!0)},this.getSplitHeight=function(){return b(!1,!0)},this.getSplitColInterval=function(){return y(!0)},this.getSplitRowInterval=function(){return y(!1)},this.setDynamicSplit=function(e,t,i){var n=this.getSplitWidthHmm(),o=this.getSplitHeightHmm();return i=_.isObject(i)?_.clone(i):{},_.extend(i,{splitMode:M.SPLIT,splitWidth:e,splitHeight:t}),n>0&&0===i.splitWidth?i.anchorRight=this.getViewAttribute("anchorLeft"):0===n&&i.splitWidth>0&&(i.anchorLeft=this.getViewAttribute("anchorRight")),o>0&&0===i.splitHeight?i.anchorBottom=this.getViewAttribute("anchorTop"):0===o&&i.splitHeight>0&&(i.anchorTop=this.getViewAttribute("anchorBottom")),this.setViewAttributes(i),this},this.setFrozenSplit=function(e,t,i){return i=_.isObject(i)?_.clone(i):{},i.splitMode=this.hasDynamicSplit()?M.FROZEN_SPLIT:M.FROZEN,e?(i.splitWidth=e.size(),i.anchorLeft=e.first,i.anchorRight=e.last+1):i.splitWidth=0,t?(i.splitHeight=t.size(),i.anchorTop=t.first,i.anchorBottom=t.last+1):i.splitHeight=0,this.setViewAttributes(i),this},this.clearSplit=function(){return this.setDynamicSplit(0,0)},this.isVisible=function(){return this.getMergedAttributeSet(!0).sheet.visible},this.isLocked=function(){return!this.isWorksheet()||this.getMergedAttributeSet(!0).sheet.locked},this.getZoom=function(){return K},this.setZoom=function(e){return this.setViewAttribute("zoom",e),this},this.isGridVisible=function(){return this.isCellType()&&this.getViewAttribute("showGrid")},this.toggleGridVisibility=function(e){return this.isCellType()&&this.setViewAttribute("showGrid",e),this},this.getGridColor=function(){return r.parseJSON(this.getMergedAttributeSet(!0).sheet.gridColor)||new r("auto")},this.initializeViewAttributes=_.once(function(){var i=t.addressFactory,n=this.getMergedAttributeSet(!0).sheet,r=i.parseRangeList(n.selectedRanges),l=e.getIntegerOption(n,"activeIndex",0),s=i.parseAddress(n.activeCell),a=e.getArrayOption(n,"selectedDrawings",[]),c=r?new W(o(r),l,s,a):null,u={zoom:n.zoom,showGrid:n.showGrid,splitMode:O(M,n.splitMode,M.SPLIT),splitWidth:n.splitWidth,splitHeight:n.splitHeight,activePane:n.activePane,anchorLeft:n.scrollLeft,anchorRight:n.scrollRight,anchorTop:n.scrollTop,anchorBottom:n.scrollBottom};return c?(c.active!==n.activeIndex&&e.warn("SheetModel.initializeViewAttributes(): sheet="+this.getIndex()+", invalid range index in selection"),c.activeRange().containsAddress(c.address)||(e.warn("SheetModel.initializeViewAttributes(): sheet="+this.getIndex()+", invalid active cell in selection"),c.address=c.activeRange().start.clone())):(e.warn("SheetModel.initializeViewAttributes(): sheet="+this.getIndex()+", invalid selection"),(c=W.createFromAddress(V.A1)).ranges=o(c.ranges)),u.selection=c,0===n.splitWidth&&(u.activePane=h.getNextPanePos(u.activePane,"right"),u.anchorRight=u.anchorLeft,delete u.anchorLeft),0===n.splitHeight&&(u.activePane=h.getNextPanePos(u.activePane,"bottom"),u.anchorBottom=u.anchorTop,delete u.anchorTop),this.setViewAttributes(u),this}.bind(this)),this.getChangedViewAttributes=function(){function e(e,i){return Math.min(Math.round(e),t.getMaxIndex(i))}var i=this.getMergedAttributeSet(!0).sheet,n=this.getViewAttributes(),o={selectedRanges:n.selection.ranges.toOpStr(),activeIndex:n.selection.active,activeCell:n.selection.address.toOpStr(),selectedDrawings:n.selection.drawings,zoom:n.zoom,showGrid:n.showGrid,splitWidth:n.splitWidth,splitHeight:n.splitHeight,activePane:n.activePane,scrollLeft:e(n.anchorLeft,!0),scrollRight:e(n.anchorRight,!0),scrollTop:e(n.anchorTop,!1),scrollBottom:e(n.anchorBottom,!1)},r=n.splitWidth>0,l=n.splitHeight>0;r||(o.activePane=h.getNextPanePos(o.activePane,"left"),o.scrollLeft=o.scrollRight,delete o.scrollRight),l||(o.activePane=h.getNextPanePos(o.activePane,"top"),o.scrollTop=o.scrollBottom,delete o.scrollBottom);var s=r||l?n.splitMode:M.SPLIT;return o.splitMode=s,s!==M.SPLIT&&(o.activePane=r?l?"bottomRight":"topRight":"bottomLeft"),_.each(o,function(e,t){_.isEqual(i[t],e)&&delete o[t]}),o},this.refreshRanges=function(e){return(e=L(e)).empty()||this.trigger("refresh:ranges",e),this},this.canRestoreDeletedRanges=function(e){return this.tableCollection.canRestoreDeletedRanges(e)&&this.drawingCollection.canRestoreDeletedRanges(e)},this.createOperationGenerator=function(e){var i=t.createSheetOperationGenerator(e);return i.setSheetIndex(this.getIndex()),i},this.createAndApplyOperations=function(e,i){return t.createAndApplySheetOperations(function(t){return t.setSheetIndex(q.getIndex()),e.call(q,t)},i)},this.generateChangeSheetOperations=function(e,t){return e.generateSheetOperation(a.CHANGE_SHEET,{attrs:this.getUndoAttributeSet(t)},{undo:!0}),e.generateSheetOperation(a.CHANGE_SHEET,{attrs:t}),this},this.generateRestoreOperations=function(){return this.createResolvedPromise()},this.generateBeforeMoveCellsOperations=k.profileMethod("SheetModel.generateBeforeMoveCellsOperations()",function(t,i){return e.invokeChainedAsync(function(){return q.mergeCollection.generateBeforeMoveCellsOperations(t,i)},function(){return q.hyperlinkCollection.generateBeforeMoveCellsOperations(t,i)},function(){return q.tableCollection.generateBeforeMoveCellsOperations(t,i)},function(){return q.drawingCollection.generateBeforeMoveCellsOperations(t,i)},function(){return q.commentCollection.generateBeforeMoveCellsOperations(t,i)},function(){return q.threadedCommentCollection.generateBeforeMoveCellsOperations(t,i)})}),this.generateUpdateFormulaOperations=k.profileMethod("SheetModel.generateUpdateFormulaOperations()",function(t,i,n){var o="only"===n,r="skip"===n;return e.invokeChainedAsync(o?null:function(){return q.cellCollection.generateUpdateFormulaOperations(t,i)},o?null:function(){return q.nameCollection.generateUpdateFormulaOperations(t,i)},o?null:function(){return q.validationCollection.generateUpdateFormulaOperations(t,i)},o?null:function(){return q.condFormatCollection.generateUpdateFormulaOperations(t,i)},r?null:function(){return q.drawingCollection.generateUpdateFormulaOperations(t,i)},r?null:function(){return q.commentCollection.generateUpdateFormulaOperations(t,i)},r?null:function(){return q.threadedCommentCollection.generateUpdateFormulaOperations(t,i)})}),this.generateRefreshAnchorOperations=k.profileMethod("SheetModel.generateRefreshAnchorOperations()",function(t){return e.invokeChainedAsync(function(){return q.drawingCollection.generateRefreshAnchorOperations(t)},function(){return q.commentCollection.generateRefreshAnchorOperations(t)},function(){return q.threadedCommentCollection.generateRefreshAnchorOperations(t)})}),this.nameCollection=new g(this),this.colCollection=new d(this,!0),this.rowCollection=new d(this,!1),this.mergeCollection=new f(this),this.cellCollection=new p(this),this.hyperlinkCollection=new m(this),this.tableCollection=new C(this),this.validationCollection=new v(this),this.condFormatCollection=new w(this),this.drawingCollection=new S(this),this.commentCollection=new R(this),this.threadedCommentCollection=new x(this),this.colCollection.on({"insert:entries":function(e,t){Z("insert:columns",t,!0,!0)},"delete:entries":function(e,t){Z("delete:columns",t,!1,!0)},"change:entries":function(e,t,i){q.trigger("change:columns",t,i)}}),this.rowCollection.on({"insert:entries":function(e,t){Z("insert:rows",t,!0,!1)},"delete:entries":function(e,t){Z("delete:rows",t,!1,!1)},"change:entries":function(e,t,i){q.trigger("change:rows",t,i)}}),this.mergeCollection.on("triggered",function(){var e=q.getViewAttribute("selection").clone();e.ranges=o(e.ranges),q.setViewAttribute("selection",e)}),this.cellCollection.on("change:usedrange",function(){q.trigger("change:usedrange",q.getUsedRange())}),this.mergeCollection.on("change:usedrange",function(){q.trigger("change:usedrange",q.getUsedRange())}),this.drawingCollection.on({"insert:drawing":function(e,t){var i=q.getViewAttribute("selection");if(0!==i.drawings.length){var n=t.getPosition(),o=n.length,r=_.last(n);(i=i.clone()).drawings.forEach(function(e){e.length<o||T(n,e,o-1)&&r<=e[o-1]&&(e[o-1]+=1)}),q.setViewAttribute("selection",i)}},"delete:drawing":function(e,t){var i=q.getViewAttribute("selection");if(0!==i.drawings.length){var n=t.getPosition(),o=n.length,r=_.last(n);i=i.clone(),H(i.drawings,function(e,t){e.length<o||T(n,e,o-1)&&(r===e[o-1]?i.drawings.splice(t,1):r<e[o-1]&&(e[o-1]-=1))}),q.setViewAttribute("selection",i)}},"move:drawing":function(e,t,i){var n=q.getViewAttribute("selection");if(0!==n.drawings.length){var o=t.getPosition(),r=o.length,l=_.last(o);(n=n.clone()).drawings.forEach(function(e){e.length<r||T(o,e,r-1)&&(e[r-1]=c.transformIndex(e[r-1],i,l))}),q.setViewAttribute("selection",n)}}}),this.forwardEvents(this.nameCollection),this.forwardEvents(this.mergeCollection,{except:"change:usedrange"}),this.forwardEvents(this.cellCollection,{except:"change:usedrange"}),this.forwardEvents(this.hyperlinkCollection),this.forwardEvents(this.condFormatCollection),this.forwardEvents(this.tableCollection),this.forwardEvents(this.drawingCollection),this.commentCollection.on({"insert:drawing":function(e,t){q.trigger("insert:comment",t)},"delete:drawing":function(e,t){q.trigger("delete:comment",t)},"change:drawing":function(e,t){q.trigger("change:comment",t)},"change:drawing:text":function(e,t){q.trigger("change:comment:text",t)},"move:drawing":function(e,t,i){q.trigger("move:comment",t,i)}}),this.registerDestructor(function(){this.commentCollection.destroy(),this.threadedCommentCollection.destroy(),this.drawingCollection.destroy(),this.condFormatCollection.destroy(),this.validationCollection.destroy(),this.tableCollection.destroy(),this.cellCollection.destroy(),this.hyperlinkCollection.destroy(),this.mergeCollection.destroy(),this.colCollection.destroy(),this.rowCollection.destroy(),this.nameCollection.destroy(),q=t=null})})})});