define("io.ox/office/spreadsheet/utils/range",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address"],function(t,e,r,n,s,o){"use strict";function i(t,e){return t.key+":"+e.key}Object.defineProperty(e,"__esModule",{value:!0});var a=Math.min,u=Math.max,c=Math.floor,h="("+o.COL_PATTERN+")("+o.ROW_PATTERN+")",p=new RegExp("^"+h+":"+h+"$","i");e.rangeKeyFromIndexes=function(t,e,r,n){return o.addressKey(t,e)+":"+o.addressKey(r,n)},e.rangeKey=i;var d=function(){function t(t,e){this.start=t,this.end=e||t.clone()}return t.create=function(e,r,n,s){return new t(new o.Address(a(e,n),a(r,s)),new o.Address(u(e,n),u(r,s)))},t.createFromIntervals=function(e,r){return t.create(e.first,r.first,e.last,r.last)},t.createFromColInterval=function(e,n,s){return r.isNumber(s)||(s=n),t.create(e.first,n,e.last,s)},t.createFromRowInterval=function(e,n,s){return r.isNumber(s)||(s=n),t.create(n,e.first,s,e.last)},t.createFromAddresses=function(e,r){return r?t.create(e[0],e[1],r[0],r[1]):new t(e.clone())},t.createFromAddressAndSize=function(e,r,n){return t.create(e[0],e[1],e[0]+r-1,e[1]+n-1)},t.parse=function(e){var r=e.match(p);if(r){var n=o.parseCol(r[1]),s=o.parseRow(r[2]),i=o.parseCol(r[3]),u=o.parseRow(r[4]);return a(n,s,i,u)>=0?t.create(n,s,i,u):null}var c=o.Address.parse(e);return c?new t(c):null},t.compare=function(t,e){return n.comparePairs(t.start,t.end,e.start,e.end,o.Address.compare)},Object.defineProperty(t.prototype,"key",{get:function(){return i(this.start,this.end)},enumerable:!0,configurable:!0}),t.prototype.clone=function(){return new t(this.start.clone(),this.end.clone())},t.prototype.equals=function(t){return this.start.equals(t.start)&&this.end.equals(t.end)},t.prototype.differs=function(t){return this.start.differs(t.start)||this.end.differs(t.end)},t.prototype.compareTo=function(e){return t.compare(this,e)},t.prototype.cols=function(){return this.end[0]-this.start[0]+1},t.prototype.rows=function(){return this.end[1]-this.start[1]+1},t.prototype.size=function(t){return t?this.cols():this.rows()},t.prototype.cells=function(){return this.cols()*this.rows()},t.prototype.singleCol=function(){return this.start[0]===this.end[0]},t.prototype.singleRow=function(){return this.start[1]===this.end[1]},t.prototype.singleLine=function(t){return t?this.singleCol():this.singleRow()},t.prototype.single=function(){return this.start.equals(this.end)},t.prototype.equalSize=function(t){return this.cols()===t.cols()&&this.rows()===t.rows()},t.prototype.sizeFitsInto=function(t){return t.cols()%this.cols()==0&&t.rows()%this.rows()==0},t.prototype.startsAt=function(t){return this.start.equals(t)},t.prototype.endsAt=function(t){return this.end.equals(t)},t.prototype.indexAt=function(t){return(t[1]-this.start[1])*this.cols()+(t[0]-this.start[0])},t.prototype.addressAt=function(t){var e=this.cols();return new o.Address(this.start[0]+c(t%e),this.start[1]+c(t/e))},t.prototype.containsCol=function(t){return this.start[0]<=t&&t<=this.end[0]},t.prototype.containsRow=function(t){return this.start[1]<=t&&t<=this.end[1]},t.prototype.containsIndex=function(t,e){return e?this.containsCol(t):this.containsRow(t)},t.prototype.containsAddress=function(t){return this.containsCol(t[0])&&this.containsRow(t[1])},t.prototype.isBorderAddress=function(t){return this.containsAddress(t)&&(this.start[0]===t[0]||this.end[0]===t[0]||this.start[1]===t[1]||this.end[1]===t[1])},t.prototype.contains=function(t){return this.containsAddress(t.start)&&this.containsAddress(t.end)},t.prototype.overlaps=function(t){return this.start[0]<=t.end[0]&&t.start[0]<=this.end[0]&&this.start[1]<=t.end[1]&&t.start[1]<=this.end[1]},t.prototype.colInterval=function(){return new s.Interval(this.start[0],this.end[0])},t.prototype.rowInterval=function(){return new s.Interval(this.start[1],this.end[1])},t.prototype.interval=function(t){return t?this.colInterval():this.rowInterval()},t.prototype.colRange=function(e,r){void 0===r&&(r=1);var n=this.start[0]+e;return t.create(n,this.start[1],n+r-1,this.end[1])},t.prototype.rowRange=function(e,r){void 0===r&&(r=1);var n=this.start[1]+e;return t.create(this.start[0],n,this.end[0],n+(r||1)-1)},t.prototype.lineRange=function(t,e,r){return void 0===r&&(r=1),t?this.colRange(e,r):this.rowRange(e,r)},t.prototype.leadingCol=function(){return t.create(this.start[0],this.start[1],this.start[0],this.end[1])},t.prototype.trailingCol=function(){return t.create(this.end[0],this.start[1],this.end[0],this.end[1])},t.prototype.headerRow=function(){return t.create(this.start[0],this.start[1],this.end[0],this.start[1])},t.prototype.footerRow=function(){return t.create(this.start[0],this.end[1],this.end[0],this.end[1])},t.prototype.mirror=function(){return t.create(this.start[1],this.start[0],this.end[1],this.end[0])},t.prototype.expand=function(e){return t.create(a(this.start[0],e[0]),a(this.start[1],e[1]),u(this.end[0],e[0]),u(this.end[1],e[1]))},t.prototype.boundary=function(e){return t.create(a(this.start[0],e.start[0]),a(this.start[1],e.start[1]),u(this.end[0],e.end[0]),u(this.end[1],e.end[1]))},t.prototype.intersect=function(e){return this.overlaps(e)?t.create(u(this.start[0],e.start[0]),u(this.start[1],e.start[1]),a(this.end[0],e.end[0]),a(this.end[1],e.end[1])):null},t.prototype.getStart=function(t){return this.start.get(t)},t.prototype.getEnd=function(t){return this.end.get(t)},t.prototype.setStart=function(t,e){return this.start.set(t,e),this},t.prototype.setEnd=function(t,e){return this.end.set(t,e),this},t.prototype.setBoth=function(t,e){return this.start.set(t,e),this.end.set(t,e),this},t.prototype.moveBoth=function(t,e){return this.start.move(t,e),this.end.move(t,e),this},t.prototype.iterator=function(t){var e=!(!t||!t.columns),r=this.interval(e),n=this.interval(!e);return r.iterator(t).nestedMapIterator(function(){return n.iterator(t)},e?function(t,e){return{value:new o.Address(t.value,e.value)}}:function(t,e){return{value:new o.Address(e.value,t.value)}})},t.prototype.toOpStr=function(){var t=this.start.toOpStr();return this.single()?t:t+":"+this.end.toOpStr()},t.prototype.toString=function(){return this.start+":"+this.end},t}();e.Range=d});