define("io.ox/office/spreadsheet/utils/sheetutils",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/utils/device","io.ox/office/tk/utils/logger","io.ox/office/tk/locale/locale","io.ox/office/tk/render/font","gettext!io.ox/office/spreadsheet/main","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/range3d","io.ox/office/spreadsheet/utils/intervalarray","io.ox/office/spreadsheet/utils/addressarray","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/utils/range3darray","io.ox/office/spreadsheet/utils/intervalset","io.ox/office/spreadsheet/utils/addressset","io.ox/office/spreadsheet/utils/rangeset","io.ox/office/spreadsheet/utils/cellanchor"],function(e,t,r,i,o,n,s,a,f,c,u,l,d,g,T,E,L,A,O,h,p,N){"use strict";function C(e){for(var r in e)t.hasOwnProperty(r)||(t[r]=e[r])}function x(e){return e===s.TextDirection.RTL?"right":"left"}function I(e,t){return e?t?"l":"r":t?"t":"b"}function R(e){return e?"v":"h"}function M(e){return b(e/4)}function D(e){return e===m.UP||e===m.DOWN}function S(e){return e===m.LEFT||e===m.UP}Object.defineProperty(t,"__esModule",{value:!0});var b=Math.ceil;C(c),C(u),C(l),C(d),C(g),C(T),C(E),C(L),C(A),C(O),C(h),C(p),C(N);!function(e){e.WORKSHEET="worksheet",e.CHARTSHEET="chartsheet",e.MACROSHEET="macrosheet",e.DIALOGSHEET="dialogsheet"}(t.SheetType||(t.SheetType={}));!function(e){e.SPLIT="split",e.FROZEN="frozen",e.FROZEN_SPLIT="frozenSplit"}(t.SplitMode||(t.SplitMode={}));var m;!function(e){e.LEFT="left",e.RIGHT="right",e.UP="up",e.DOWN="down"}(m=t.Direction||(t.Direction={}));var H;!function(e){e.MERGE="merge",e.HORIZONTAL="horizontal",e.VERTICAL="vertical",e.UNMERGE="unmerge"}(H=t.MergeMode||(t.MergeMode={}));!function(e){e[e.VERTICAL=0]="VERTICAL",e[e.HORIZONTAL=1]="HORIZONTAL"}(t.SortDirection||(t.SortDirection={}));!function(e){e.ABSOLUTE="absolute",e.ONE_CELL="oneCell",e.TWO_CELL="twoCell"}(t.AnchorMode||(t.AnchorMode={}));var y={l:"borderLeft",r:"borderRight",t:"borderTop",b:"borderBottom",d:"borderDown",u:"borderUp",v:"borderInsideVert",h:"borderInsideHor"},U={left:"left",center:"center",right:"right",justify:"justify",distribute:"justify",fillAcross:"left",centerAcross:"center"};t.CELL_POOL_ID="cell",t.MAX_NAME_LENGTH=255,t.MAX_FILL_CELL_COUNT=2e4,t.MAX_AUTOFILL_COL_ROW_COUNT=100,t.MAX_MERGED_RANGES_COUNT=1e3,t.MAX_UNMERGE_CELL_COUNT=5e3,t.MAX_CHANGE_COLS_COUNT=2e4,t.MAX_CHANGE_ROWS_COUNT=5e3,t.MAX_SORT_LINES_COUNT=5e3,t.MAX_SORT_LINE_LENGTH=100,t.MAX_LENGTH_STANDARD_CELL=11,t.MAX_LENGTH_STANDARD_EDIT=21,t.MAX_LENGTH_STANDARD_FORMULA=20,t.MIN_CELL_SIZE=5,t.MAX_BORDER_WIDTH=t.MIN_CELL_SIZE,t.MULTI_SELECTION=!o.TOUCH_DEVICE,t.modelLogger=new n.Logger("spreadsheet:log-models",{tag:"MODEL",tagColor:65280}),t.makeRejected=function(e){return r.newRejected({cause:e})},t.getNameKey=function(e){return e.toUpperCase()},t.getTableKey=function(e){return e.toUpperCase()},t.getSheetName=function(e){return _.noI18n.fix(f("Sheet%1$d",_.noI18n(String(e))))},t.getTableName=function(){return _.noI18n.fix(f.pgettext("filter","Table"))},t.getTableColName=function(){return _.noI18n.fix(f.pgettext("filter","Column"))},t.hasWrappingAttributes=function(e){var t=e.cell;return!!t.wrapText||"justify"===t.alignHor||"justify"===t.alignVert},t.getTextOrientation=function(e,t,i){var o=r.isString(i)?a.getTextDirection(i):s.LOCALE_DATA.dir,n=U[t];if(!n)switch(typeof e){case"string":n=x(e===i?o:a.getTextDirection(e));break;case"number":n="right";break;default:n=null===e?x(s.LOCALE_DATA.dir):"center"}return{textDir:o,cssTextAlign:n,baseBoxAlign:"justify"===n?x(o):n}},t.getOuterBorderKey=I,t.getInnerBorderKey=R,t.getBorderName=function(e){return y[e]},t.getOuterBorderName=function(e,t){return y[I(e,t)]},t.getInnerBorderName=function(e){return y[R(e)]},t.getTextPadding=M,t.getTotalCellPadding=function(e){return 2*M(e)+1},t.isVerticalDir=D,t.isLeadingDir=S,t.getDirection=function(e,t){return e?t?m.UP:m.DOWN:t?m.LEFT:m.RIGHT},t.transformIndex=function(e,t,r){return e===t?r:t<e&&e<=r?e-1:r<=e&&e<t?e+1:e},t.getAdjacentRange=function(e,t,r){var i=!D(t),o=e.clone();return S(t)?(o.start.move(-r,i),o.end.set(e.start.get(i)-1,i)):(o.start.set(e.end.get(i)+1,i),o.end.move(r,i)),o},t.isOriginCell=function(e,t,r){switch(r){case H.MERGE:return t.startsAt(e);case H.HORIZONTAL:return t.start[0]===e[0];case H.VERTICAL:return t.start[1]===e[1]}return!1},t.splitDisplayString=function(e){return e.split(/\n/).map(i.cleanString)}});